SystemOrganization addCategory: #UnixMetaStack!

StackEvtAndroidConfig subclass: #MetaStackEvtAndroidConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack'!

!MetaStackEvtAndroidConfig methodsFor: 'as yet unclassified' stamp: 'np 9/9/2013 12:34'!
executableName
	^ 'MetaStackVM'! !

!MetaStackEvtAndroidConfig methodsFor: 'as yet unclassified' stamp: 'np 9/9/2013 12:35'!
interpreterClass
	^ MetaStackEvtAndroidInterpreter! !

StackInterpreterPrimitives subclass: #MetaStackInterpreter
	instanceVariableNames: ''
	classVariableNames: 'AllButExperimentalBit ExperimentalObjectBit'
	poolDictionaries: ''
	category: 'UnixMetaStack'!

!MetaStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:27'!
initialize

	super initialize.
	BytesPerWord ifNil: [BytesPerWord := 4].  "May get called on fileIn, so supply default"	
	WordMask := (1 bitShift: BytesPerWord*8) - 1.
	ExperimentalObjectBit := 1 bitShift: BytesPerWord *8 - 3.  "Next-to-Top bit"
	AllButExperimentalBit  := WordMask - ExperimentalObjectBit.! !

!MetaStackInterpreter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2013 12:07'!
initializePrimitiveTable

	super initializePrimitiveTable.
	
	PrimitiveTable at: 150 + 1 put: #primitiveGetExperimentalBit.
	PrimitiveTable at: 151 + 1 put: #primitiveSetExperimentalBit.
	PrimitiveTable at: 152 + 1 put: #primitiveTurnOffExperimentalBitOfAllObjects.! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides-placeholders' stamp: 'NickPapoulias 5/28/2013 13:28'!
commonReturn
	"Do an ^-return (return form method), perhaps checking for unwinds if this is a block activation.
	 Note: Assumed to be inlined into the dispatch loop."

	super commonReturn! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides' stamp: 'NickPapoulias 3/13/2014 12:58'!
commonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSend' inCase: #singleExtendedSendBytecode>
		
	(objectMemory splObj: 63) == (self receiver) ifTrue: [ "sender is Interpreter"
		^ super commonSend.
	].

	(objectMemory splObj: 63) == (self internalStackValue: argumentCount ) ifTrue: ["receiver is Interpreter -- this is from wherever"
		^ super commonSend.
	].
	
	(objectMemory splObj: 65) == (self receiver) ifTrue: [ "sender is the baseMetaDict"
		^ super commonSend.
	].

	(self shouldOverrideBehaviorFor: self receiver) ifTrue: [ "override for sender"
		^ self sendMetaSendFor: self receiver.
	].

	(self shouldOverrideBehaviorFor: (self internalStackValue: argumentCount)) ifTrue: [ "override fo receiver"
		^ self sendMetaReceivedFor: (self internalStackValue: argumentCount).
	].
	

	
	
	0 to: argumentCount - 1 do: [:argIndex | "override for args" 
		 (self shouldOverrideBehaviorFor: (self internalStackValue: argIndex)) ifTrue: [
					^ self sendMetaArgFor: (self internalStackValue: argIndex)
		]
	].
	
	(self shouldOverrideBehaviorFor: newMethod) ifTrue: [
		"should distinguish between method as object and method as method"
		^ self sendMetaSendFor: newMethod.	
	].
	
	self sendBreak: messageSelector + BaseHeaderSize
		point: (objectMemory lengthOf: messageSelector)
		receiver: (self internalStackValue: argumentCount).
	self printSends ifTrue:
		[self printActivationNameForSelector: messageSelector startClass: lkupClass; cr].
	self internalFindNewMethod.
	(self shouldOverrideBehaviorFor: newMethod) ifTrue: [
		^ self sendMetaInvokedFor: newMethod.	
	].
	self internalExecuteNewMethod.
	self fetchNextBytecode
	
	! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides' stamp: 'NickPapoulias 5/9/2013 15:39'!
externalQuickPrimitiveResponse
	"Invoke a quick primitive.
	 Called under the assumption that primFunctionPtr has been preloaded"
	
	| localPrimIndex array |
	self assert: self isPrimitiveFunctionPointerAnIndex.
	localPrimIndex := self cCoerceSimple: primitiveFunctionPointer to: #sqInt.
	self assert: (localPrimIndex > 255 and: [localPrimIndex < 520]).
	"Quick return inst vars"
	localPrimIndex >= 264 ifTrue: [
		(self shouldOverrideBehaviorFor: self stackTop) ifTrue: [
			self unsetOverrideBehaviorFor: self stackTop.
			array := objectMemory eeInstantiateClass: (objectMemory splObj: ClassArray) indexableSize: 1.
			objectMemory storePointerUnchecked: 0 ofObject: array withValue: (self integerObjectOf: (localPrimIndex - 264 + 1)).
			self primitiveObject: self stackTop
				perform: (objectMemory splObj: 60) 
				withArguments:  array
				lookedUpIn: (objectMemory fetchClassOf: self stackTop).
			^ true.
		] ifFalse: [
			self pop: 1 thenPush: (objectMemory fetchPointer: localPrimIndex - 264 ofObject: self stackTop).
		 	^true
		].
	].
	"Quick return constants"
	localPrimIndex = 256 ifTrue: [^true "return self"].
	localPrimIndex = 257 ifTrue: [self pop: 1 thenPush: objectMemory trueObject. ^true].
	localPrimIndex = 258 ifTrue: [self pop: 1 thenPush: objectMemory falseObject. ^true].
	localPrimIndex = 259 ifTrue: [self pop: 1 thenPush: objectMemory nilObject. ^true].
	self pop: 1 thenPush: (objectMemory integerObjectOf: localPrimIndex - 261).
	^true
! !

!MetaStackInterpreter methodsFor: 'experimental-bit-accesors' stamp: 'NickPapoulias 4/30/2013 17:58'!
getExperimentalBitOf: anOop
	self inline: true.
	^((objectMemory baseHeader: anOop) bitAnd: ExperimentalObjectBit) ~= 0 ! !

!MetaStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 5/7/2013 15:58'!
primitiveGetExperimentalBit
	| rcvr hdr |
	rcvr := self stackTop.
	(self isIntegerObject: rcvr)
		ifTrue:
			[self primitiveFail ]
		ifFalse:
			[ self pop: 2. 
			self pushBool: (self getExperimentalBitOf: rcvr) ]! !

!MetaStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 5/7/2013 15:28'!
primitiveSetExperimentalBit
	| boolean rcvr hdr wasImmutable |
	rcvr := self stackValue: 1.
	(self isIntegerObject: rcvr) ifTrue:
		[^self primitiveFailFor: PrimErrInappropriate].
	boolean := self booleanValueOf: self stackTop.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	self setExperimentalBitOf: rcvr to: boolean.
	self pop: 2! !

!MetaStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 5/5/2013 19:07'!
primitiveTurnOffExperimentalBitOfAllObjects
	| oop |
	oop := self firstAccessibleObject.
	[oop = nil] whileFalse: [
		(self isIntegerObject:  oop)
			ifFalse: [ 
				self setExperimentalBitOf: oop to: false
				].
		oop := self accessibleObjectAfter: oop.
	].
	
! !

!MetaStackInterpreter methodsFor: 'print-debugging' stamp: 'NickPapoulias 4/30/2013 18:01'!
print: s
	
	<api>
	<var: #s type: #'char *'>
	self cCode: 'fputs(s, stdout); fflush(stdout);'! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides-placeholders' stamp: 'NickPapoulias 5/5/2013 17:04'!
pushLiteralVariable: literalIndex

	"place holder for hooking metaRef if needed"

	super pushLiteralVariable: literalIndex.
! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides-placeholders' stamp: 'NickPapoulias 5/5/2013 17:05'!
pushReceiverBytecode

	"place holder for hooking metaRef if needed"

	super pushReceiverBytecode.
! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides' stamp: 'NickPapoulias 5/5/2013 17:05'!
pushReceiverVariable: fieldIndex

	|iv object|

	self inline: true.
	
	object := self receiver.
	
	(self shouldOverrideBehaviorFor: object) ifTrue: [
		self sendMetaReadAtFor: object withIndex: (self integerObjectOf: fieldIndex + 1). 
	] ifFalse: [
		super pushReceiverVariable: fieldIndex.
	].
	
	
! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides-placeholders' stamp: 'NickPapoulias 5/5/2013 17:06'!
pushTemporaryVariable: temporaryIndex

	super pushTemporaryVariable: temporaryIndex.

	
! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 5/29/2013 16:42'!
sendMetaArgFor: object

	| message rcvr |
	self inline: true.

	self unsetOverrideBehaviorFor: object.
	rcvr := self internalStackValue: argumentCount .
	self externalizeIPandSP.
	self createActualMessageTo: lkupClass.
	message := self stackTop.
	self internalizeIPandSP.
	self internalPop: 2.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: message. "push the interpreter which is the receiver"
	self internalPush: rcvr.
	messageSelector := objectMemory splObj: 75. 
	argumentCount := 3. 
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 3/13/2014 08:42'!
sendMetaInvokedFor:  object	

	| rcvr message |
	self inline: true.

	self unsetOverrideBehaviorFor: object.
	rcvr := self internalStackValue: argumentCount .
	self externalizeIPandSP.
	self createActualMessageTo: lkupClass.
	message := self stackTop.
	self internalizeIPandSP.
	self internalPop: 2.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: message.
	self internalPush: rcvr.
	messageSelector := objectMemory splObj: 77.
	argumentCount := 3. 
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 5/29/2013 15:12'!
sendMetaReadAtFor: object withIndex: index

	"self inline: true."

	self unsetOverrideBehaviorFor: object.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: index.
	messageSelector := objectMemory splObj: 73.
	argumentCount := 2.
	self undoFetchNextBytecode. "hail marry hack"
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 5/29/2013 15:02'!
sendMetaReceivedFor: object

	| message |
	self inline: true.

	self unsetOverrideBehaviorFor: object.
	self externalizeIPandSP.
	self createActualMessageTo: lkupClass.
	message := self stackTop.
	self internalizeIPandSP.
	self internalPop: 2.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: message. "push the interpreter which is the receiver"
	argumentCount := 2.
	messageSelector := objectMemory splObj: 71. 
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 4/30/2013 18:16'!
sendMetaReferenceFor: object 

	self inline: true.
	
	self unsetOverrideBehaviorFor: object.
	self internalPush: object.
	messageSelector := objectMemory splObj: 59.
	argumentCount := 0.
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 5/29/2013 16:24'!
sendMetaSendFor: object

	| rcvr message |
	self inline: true.

	self unsetOverrideBehaviorFor: object.
	rcvr := self internalStackValue: argumentCount .
	self externalizeIPandSP.
	self createActualMessageTo: lkupClass.
	message := self stackTop.
	self internalizeIPandSP.
	self internalPop: 2.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: message.
	self internalPush: rcvr.
	messageSelector := objectMemory splObj: 72.
	argumentCount := 3. 
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 6/17/2013 10:39'!
sendMetaStoreFor: object inIndex: index ofObject: anotherObject

	self inline: true.

	self unsetOverrideBehaviorFor: object.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: index.
	self internalPush: anotherObject.
	messageSelector := objectMemory splObj: 76.
	argumentCount := 3.
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'meta-protocol' stamp: 'NickPapoulias 5/29/2013 15:15'!
sendMetaWriteAtPutFor: object withIndex: index andValue: value 

	self inline: true.

	self unsetOverrideBehaviorFor: object.
	self internalPush: (objectMemory splObj: 63).
	self internalPush: object.
	self internalPush: index.
	self internalPush: value.
	messageSelector := objectMemory splObj: 74.
	argumentCount := 3.
	self normalSend.! !

!MetaStackInterpreter methodsFor: 'experimental-bit-accesors' stamp: 'NickPapoulias 4/30/2013 17:59'!
setExperimentalBitOf: anOop to: boolean
	| hdr |
	self inline: true.
	"Dont check here if it is integer. Check in the sender of this."
	hdr := objectMemory baseHeader: anOop.
	boolean 
		ifTrue: [ objectMemory baseHeader: anOop put: (hdr bitOr: ExperimentalObjectBit). ]
		ifFalse: [ objectMemory baseHeader: anOop put: (hdr bitAnd: AllButExperimentalBit). ]! !

!MetaStackInterpreter methodsFor: 'meta-jump-accesors' stamp: 'NickPapoulias 5/5/2013 17:09'!
setOverrideBehaviorFor: object

	self inline: true.
	
	objectMemory baseHeader: object put: ((objectMemory baseHeader: object) bitOr: (ExperimentalObjectBit))! !

!MetaStackInterpreter methodsFor: 'meta-jump-accesors' stamp: 'NickPapoulias 5/5/2013 17:09'!
shouldOverrideBehaviorFor: object
	
	self inline: true.
	
	^ (objectMemory isIntegerObject: object) not  & (objectMemory getExperimentalBitOf: object)! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides' stamp: 'NickPapoulias 6/17/2013 10:14'!
storeAndPopReceiverVariableBytecode

	| rcvr top |

	self inline: true.

	rcvr := self receiver.
	top := self internalStackTop.

	(self shouldOverrideBehaviorFor: rcvr) ifTrue: [
		^ self sendMetaWriteAtPutFor: rcvr withIndex: (self integerObjectOf: (currentBytecode bitAnd: 7) + 1) andValue: top.
	]. 

	(self shouldOverrideBehaviorFor: top) ifTrue: [
		^ self sendMetaStoreFor: top inIndex: (self integerObjectOf: (currentBytecode bitAnd: 7) + 1) ofObject: rcvr.	
	]. 
	
	super storeAndPopReceiverVariableBytecode.
	
! !

!MetaStackInterpreter methodsFor: 'meta-protocol-overrides-placeholders' stamp: 'NickPapoulias 5/28/2013 13:26'!
storeAndPopTemporaryVariableBytecode
	
	super storeAndPopTemporaryVariableBytecode 
	
! !

!MetaStackInterpreter methodsFor: 'meta-jump-accesors' stamp: 'NickPapoulias 5/5/2013 17:09'!
unsetOverrideBehaviorFor: object
	
	self inline: true.
	
	objectMemory baseHeader: object put: ((objectMemory baseHeader: object) bitAnd: (AllButExperimentalBit)).! !

StackUnixDebugConfig subclass: #MetaStackUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack'!

!MetaStackUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/7/2013 10:05'!
executableName
	^ 'MetaStackDebugVM'! !

!MetaStackUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2013 16:13'!
interpreterClass
	^ MetaStackInterpreter! !

StackUnixConfig subclass: #MetaStackUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack'!

!MetaStackUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/7/2013 10:05'!
executableName
	^ 'MetaStackVM'! !

!MetaStackUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2013 16:13'!
interpreterClass
	^ MetaStackInterpreter! !
MetaStackInterpreter initialize!
